package com.robotoworks.example.books.net;


import com.robotoworks.mechanoid.net.JsonEntityReaderProvider;
import java.io.IOException;
import com.robotoworks.mechanoid.net.ServiceResult;
import java.io.InputStream;
import com.robotoworks.mechanoid.util.Closeables;
import com.robotoworks.mechanoid.internal.util.JsonReader;
import java.io.InputStreamReader;
import java.nio.charset.Charset;

public class GetBookResult extends ServiceResult {
	private Book book;
	public Book getBook(){
		return this.book;
	}
	
	public GetBookResult(JsonEntityReaderProvider provider, InputStream inStream) throws IOException {
		JsonReader reader = null;
		try {
			if(inStream != null) {
				reader = new JsonReader(new InputStreamReader(inStream, Charset.defaultCharset()));
			this.book = new Book();
			provider.get(Book.class).read(reader, this.book);
		}
	} finally {
		Closeables.closeSilently(reader);
	}
	}
}
