/*
 * Copyright 2013 Robotoworks Limited
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.robotoworks.mechanoid.util;

import java.io.Closeable;
import java.io.IOException;

import android.database.Cursor;

public final class Closeables {
	private Closeables(){}
	
	public static void closeSilently(Cursor closeable) {
		if(closeable == null) {
			return;
		}
		
		closeable.close();
	}
	
	public static void closeSilently(Closeable closeable) {
		if(closeable == null) {
			return;
		}
		
		try {
			closeable.close();
		} catch (IOException x) {
			// Quash
			x.printStackTrace();
		}
	}
}
