package com.robotoworks.mechanoid.db.generator

import com.robotoworks.mechanoid.db.sqliteModel.ColumnDef
import com.robotoworks.mechanoid.db.sqliteModel.ColumnType
import com.robotoworks.mechanoid.db.sqliteModel.CreateTableStatement
import com.robotoworks.mechanoid.db.sqliteModel.CreateViewStatement
import com.robotoworks.mechanoid.db.sqliteModel.Model
import com.robotoworks.mechanoid.db.sqliteModel.ResultColumn
import com.robotoworks.mechanoid.db.sqliteModel.TableDefinition

import static extension com.robotoworks.mechanoid.db.util.ModelUtil.*
import static extension com.robotoworks.mechanoid.text.Strings.*

class ActiveRecordGenerator {
		def CharSequence generate(Model model, TableDefinition stmt) '''
			/*
			 * Generated by Robotoworks Mechanoid
			 */
			package model.packageName;

			import android.content.ContentResolver;
			import android.database.Cursor;
			import android.os.Bundle;
			import android.os.Parcel;
			import android.os.Parcelable;
			
			import model.packageName.model.database.name.pascalizeContract.stmt.name.pascalize;
			import model.packageName.model.database.name.pascalizeContract.stmt.name.pascalize.Builder;
			import com.robotoworks.mechanoid.util.Closeables;
			import com.robotoworks.mechanoid.db.ActiveRecord;
			import com.robotoworks.mechanoid.db.ActiveRecordFactory;
			import com.robotoworks.mechanoid.Mechanoid;
			import com.robotoworks.mechanoid.db.AbstractValuesBuilder;
			
			public class stmt.name.pascalizeRecord extends ActiveRecord implements Parcelable {

				private static ActiveRecordFactory<stmt.name.pascalizeRecord> sFactory = new ActiveRecordFactory<stmt.name.pascalizeRecord>() {
					@Override
					public stmt.name.pascalizeRecord create(Cursor c) {
						return fromCursor(c);
					}
					
					@Override
					public String[] getProjection() {
						return PROJECTION;
					}
				};
				
				public static ActiveRecordFactory<stmt.name.pascalizeRecord> getFactory() {
					return sFactory;
				}

			    public static final Parcelable.Creator<stmt.name.pascalizeRecord> CREATOR 
			    	= new Parcelable.Creator<stmt.name.pascalizeRecord>() {
			        public stmt.name.pascalizeRecord createFromParcel(Parcel in) {
			            return new stmt.name.pascalizeRecord(in);
			        }
			
			        public stmt.name.pascalizeRecord[] newArray(int size) {
			            return new stmt.name.pascalizeRecord[size];
			        }
			    };
			    
			    public static String[] PROJECTION = {
			    	generateProjectionArrayMembers(stmt)
			    };
			    
			    public interface Indices {
			    	generateProjectionIndicesMembers(stmt)
			    }
			    
			    generateFields(stmt)
			    
			    @Override
			    protected String[] _getProjection() {
			    	return PROJECTION;
			    }
			    
			    generateAccessors(stmt)
			    
			    public stmt.name.pascalizeRecord() {
			    	super(stmt.name.pascalize.CONTENT_URI);
				}
				
				private stmt.name.pascalizeRecord(Parcel in) {
			    	super(stmt.name.pascalize.CONTENT_URI);
			    	
					setId(in.readLong());
					
					generateParcelDeserializationStatements(stmt)
				}
				
				@Override
				public int describeContents() {
				    return 0;
				}
				
				@Override
				public void writeToParcel(Parcel dest, int flags) {
					dest.writeLong(getId());
					generateParcelSerializationStatements(stmt)
				}
				
				@Override
				protected AbstractValuesBuilder createBuilder() {
					Builder builder = stmt.name.pascalize.newBuilder();

					generateBuilderStatements(stmt)
					
					return builder;
				}
				
			    @Override
				public void makeDirty(boolean dirty){
					generateMakeDirtyStatements(stmt)
				}

				@Override
				protected void setPropertiesFromCursor(Cursor c) {
					setId(c.getLong(Indices._ID));
					generateSetFromCursorStatements(stmt)
				}
				
				public static stmt.name.pascalizeRecord fromCursor(Cursor c) {
				    stmt.name.pascalizeRecord item = new stmt.name.pascalizeRecord();
				    
					item.setPropertiesFromCursor(c);
					
					item.makeDirty(false);
					
				    return item;
				}
				
				public static stmt.name.pascalizeRecord fromBundle(Bundle bundle, String key) {
					bundle.setClassLoader(stmt.name.pascalizeRecord.class.getClassLoader());
					return bundle.getParcelable(key);
				}
				
				public static stmt.name.pascalizeRecord get(long id) {
				    Cursor c = null;
				    
				    ContentResolver resolver = Mechanoid.getContentResolver();
				    
				    try {
				        c = resolver.query(stmt.name.pascalize.CONTENT_URI.buildUpon()
						.appendPath(String.valueOf(id)).build(), PROJECTION, null, null, null);
				        
				        if(!c.moveToFirst()) {
				            return null;
				        }
				        
				        return fromCursor(c);
				    } finally {
				        Closeables.closeSilently(c);
				    }
				}
			}
		'''
		
		def dispatch generateSetFromCursorStatements(CreateTableStatement stmt) '''
			FOR item : stmt.columnDefs.filter([!it.name.equals("_id")])
			var col = item as ColumnDef
			IF col.type == ColumnType::BOOLEAN
			setcol.name.pascalize(c.getInt(Indices.col.name.underscore.toUpperCase) > 0);
			ELSEIF col.type == ColumnType::BLOB
			setcol.name.pascalize(c.getBlob(Indices.col.name.underscore.toUpperCase));
			ELSE
			setcol.name.pascalize(c.getcol.type.toJavaTypeName.pascalize(Indices.col.name.underscore.toUpperCase));
			ENDIF
			ENDFOR
		'''
		
		def dispatch generateSetFromCursorStatements(CreateViewStatement stmt) '''
			var cols = stmt.viewResultColumns
			FOR item : cols.filter([!it.name.equals("_id")])
			var col = item as ResultColumn
			var type = col.inferredColumnType
			IF type == ColumnType::BOOLEAN
			setcol.name.pascalize(c.getInt(Indices.col.name.underscore.toUpperCase) > 0);
			ELSEIF type == ColumnType::BLOB
			setcol.name.pascalize(c.getBlob(Indices.col.name.underscore.toUpperCase));
			ELSE
			setcol.name.pascalize(c.gettype.toJavaTypeName.pascalize(Indices.col.name.underscore.toUpperCase));
			ENDIF
			ENDFOR
		'''

		
		def dispatch generateMakeDirtyStatements(CreateTableStatement stmt) '''
			FOR col : stmt.columnDefs.filter([!it.name.equals("_id")])
			mcol.name.pascalizeDirty = dirty;
			ENDFOR
		'''
		
		def dispatch generateMakeDirtyStatements(CreateViewStatement stmt) '''
			var cols = stmt.viewResultColumns
			FOR col : cols.filter([!it.name.equals("_id")])
			mcol.name.pascalizeDirty = dirty;
			ENDFOR
		'''

		
		def dispatch generateBuilderStatements(CreateTableStatement stmt) '''
			FOR col : stmt.columnDefs.filter([!it.name.equals("_id")])
			if(mcol.name.pascalizeDirty) {
				builder.setcol.name.pascalize(mcol.name.pascalize);
			}
			ENDFOR
		'''
		
		def dispatch generateBuilderStatements(CreateViewStatement stmt) '''
			var cols = stmt.viewResultColumns
			FOR col : cols.filter([!it.name.equals("_id")])
			if(mcol.name.pascalizeDirty) {
				builder.setcol.name.pascalize(mcol.name.pascalize);
			}
			ENDFOR
		'''

		
		def dispatch generateParcelSerializationStatements(CreateTableStatement stmt) '''
			FOR item : stmt.columnDefs.filter([!it.name.equals("_id")])
			var col = item as ColumnDef
			IF col.type == ColumnType::BOOLEAN
			dest.writeInt(mcol.name.pascalize ? 1 : 0);
			ELSEIF col.type == ColumnType::BLOB
			dest.writeByteArray(mcol.name.pascalize);
			ELSE
			dest.writecol.type.toJavaTypeName.pascalize(mcol.name.pascalize);
			ENDIF
			ENDFOR
			dest.writeBooleanArray(new boolean[] {
				FOR col : stmt.columnDefs.filter([!it.name.equals("_id")]) SEPARATOR ","
				mcol.name.pascalizeDirty
				ENDFOR
			});
		'''
		
		def dispatch generateParcelSerializationStatements(CreateViewStatement stmt) '''
			var cols = stmt.viewResultColumns
			FOR item : cols.filter([!it.name.equals("_id")])
			var col = item as ResultColumn
			var type = col.inferredColumnType
			IF type == ColumnType::BOOLEAN
			dest.writeInt(mcol.name.pascalize ? 1 : 0);
			ELSEIF type == ColumnType::BLOB
			dest.writeByteArray(mcol.name.pascalize);
			ELSE
			dest.writetype.toJavaTypeName.pascalize(mcol.name.pascalize);
			ENDIF
			ENDFOR
			dest.writeBooleanArray(new boolean[] {
				FOR col : cols.filter([!it.name.equals("_id")]) SEPARATOR ","
				mcol.name.pascalizeDirty
				ENDFOR
			});
		'''

		
		def dispatch generateParcelDeserializationStatements(CreateTableStatement stmt) '''
				var counter=-1
				FOR item : stmt.columnDefs.filter([!it.name.equals("_id")])
				var col = item as ColumnDef
				IF col.type == ColumnType::BOOLEAN
				mcol.name.pascalize = (in.readInt() > 0);
				ELSEIF col.type == ColumnType::BLOB
				mcol.name.pascalize = in.createByteArray();
				ELSE
				mcol.name.pascalize = in.readcol.type.toJavaTypeName.pascalize();
				ENDIF
				ENDFOR
				
				boolean[] dirtyFlags = new boolean[stmt.columnDefs.size - 1];
				in.readBooleanArray(dirtyFlags);
				FOR col : stmt.columnDefs.filter([!it.name.equals("_id")])
				mcol.name.pascalizeDirty = dirtyFlags[counter = counter + 1];
				ENDFOR
		'''
		
		def dispatch generateParcelDeserializationStatements(CreateViewStatement stmt) '''
				var counter=-1
				var cols = stmt.viewResultColumns
				FOR item : cols.filter([!it.name.equals("_id")])
				var col = item as ResultColumn
				var type = col.inferredColumnType
				IF type == ColumnType::BOOLEAN
				mcol.name.pascalize = (in.readInt() > 0);
				ELSEIF type == ColumnType::BLOB
				mcol.name.pascalize = in.createByteArray();
				ELSE
				mcol.name.pascalize = in.readtype.toJavaTypeName.pascalize();
				ENDIF
				ENDFOR
				
				boolean[] dirtyFlags = new boolean[cols.size - 1];
				in.readBooleanArray(dirtyFlags);
				FOR col : cols.filter([!it.name.equals("_id")])
				mcol.name.pascalizeDirty = dirtyFlags[counter = counter + 1];
				ENDFOR
		'''

		
		def dispatch getName(CreateTableStatement statement) {
			statement.name
		}
		
		def dispatch getName(CreateViewStatement statement) {
			statement.name
		}

		
		def dispatch generateProjectionArrayMembers(CreateTableStatement stmt) '''
			FOR col : stmt.columnDefs SEPARATOR ','
			stmt.name.pascalize.col.name.underscore.toUpperCase
			ENDFOR
		'''
		
		def dispatch generateProjectionArrayMembers(CreateViewStatement stmt) '''
			FOR col : stmt.viewResultColumns SEPARATOR ','
			stmt.name.pascalize.col.name.underscore.toUpperCase
			ENDFOR
		'''

		def dispatch generateProjectionIndicesMembers(CreateTableStatement stmt) '''
			var counter=-1
			FOR col : stmt.columnDefs
				int col.name.underscore.toUpperCase = counter = counter + 1;
			ENDFOR
		'''
		
		def dispatch generateProjectionIndicesMembers(CreateViewStatement stmt) '''
			var counter=-1
			FOR col : stmt.viewResultColumns
				int col.name.underscore.toUpperCase = counter = counter + 1;
			ENDFOR
		'''
		
		def dispatch generateFields(CreateTableStatement stmt) '''
			FOR item : stmt.columnDefs.filter([!it.name.equals("_id")])
			var col = item as ColumnDef
			private col.type.toJavaTypeName mcol.name.pascalize;
			private boolean mcol.name.pascalizeDirty;
			ENDFOR
		'''
		

		
		def dispatch generateFields(CreateViewStatement stmt) '''
			FOR item : stmt.viewResultColumns.filter([!it.name.equals("_id")])
			var col = item as ResultColumn
			var type = col.inferredColumnType
			private type.toJavaTypeName mcol.name.pascalize;
			private boolean mcol.name.pascalizeDirty;
			ENDFOR
		'''

		def dispatch generateAccessors(CreateTableStatement stmt) '''
			FOR item : stmt.columnDefs.filter([!it.name.equals("_id")])
			var col = item as ColumnDef
			public void setcol.name.pascalize(col.type.toJavaTypeName col.name.camelize) {
				mcol.name.pascalize = col.name.camelize;
				mcol.name.pascalizeDirty = true;
			}
			
			public col.type.toJavaTypeName getcol.name.pascalize() {
				return mcol.name.pascalize;
			}
			
			ENDFOR
		'''
		
		def dispatch generateAccessors(CreateViewStatement stmt) '''
			FOR item : stmt.viewResultColumns.filter([!it.name.equals("_id")])
			var col = item as ResultColumn
			var type = col.inferredColumnType
			public void setcol.name.pascalize(type.toJavaTypeName col.name.camelize) {
				mcol.name.pascalize = col.name.camelize;
				mcol.name.pascalizeDirty = true;
			}
			
			public type.toJavaTypeName getcol.name.pascalize() {
				return mcol.name.pascalize;
			}
			ENDFOR
		'''
}