package com.robotoworks.mechanoid.ops.generator

import com.robotoworks.mechanoid.ops.opServiceModel.Model

import static extension com.robotoworks.mechanoid.text.Strings.*
import static extension com.robotoworks.mechanoid.ops.generator.Extensions.*;

class OperationRegistryGenerator {
		def CharSequence generate(Model model) '''		
			var svc = model.service
			/*
			 * Generated by Robotoworks Mechanoid
			 */
			package model.packageName;

			import java.util.HashMap;
			
			import com.robotoworks.mechanoid.ops.OperationConfigurationRegistry;
			import com.robotoworks.mechanoid.ops.OperationConfiguration;
			
			public abstract class Abstractsvc.name.formatServiceNameOperationConfigurationRegistry extends OperationConfigurationRegistry {
				
				private HashMap<String, OperationConfiguration> mOperationConfigurations;
				
				public Abstractsvc.name.formatServiceNameOperationConfigurationRegistry() {
					
					mOperationConfigurations = new HashMap<String, OperationConfiguration>();
					
					registerOperationConfigurations();
				}
				
				protected void registerOperationConfigurations(){
					FOR op : svc.ops
					registerOperationConfiguration(op.name.pascalizeOperation.ACTION_op.name.underscore.toUpperCase, new op.name.pascalizeOperation.Configuration());
					ENDFOR
				}
				
				protected void registerOperationConfiguration(String action, OperationConfiguration config) {
					mOperationConfigurations.put(action, config);
				}
			
				@Override
				public OperationConfiguration getOperationConfiguration(String action) {
					return mOperationConfigurations.get(action);
				}
			}
			'''
			
		def CharSequence generateStub(Model model) '''
			var svc = model.service
			/*
			 * Generated by Robotoworks Mechanoid
			 */
			package model.packageName;
			
			public class svc.name.formatServiceNameOperationConfigurationRegistry extends Abstractsvc.name.formatServiceNameOperationConfigurationRegistry {
				
			}
			
		'''
}