package com.robotoworks.mechanoid.ops.generator;

import com.robotoworks.mechanoid.ops.generator.Extensions;
import com.robotoworks.mechanoid.ops.opServiceModel.Model;
import com.robotoworks.mechanoid.ops.opServiceModel.ServiceBlock;
import org.eclipse.xtend2.lib.StringConcatenation;

@SuppressWarnings("all")
public class ServiceConfigurationGenerator {
  public CharSequence generate(final Model model) {
    StringConcatenation _builder = new StringConcatenation();
    ServiceBlock svc = model.getService();
    _builder.newLineIfNotEmpty();
    _builder.append("/*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* Generated by Robotoworks Mechanoid");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    _builder.append("package ");
    String _packageName = model.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("import com.robotoworks.mechanoid.ops.OperationServiceConfiguration;");
    _builder.newLine();
    _builder.append("import com.robotoworks.mechanoid.ops.OperationConfigurationRegistry;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("public abstract class Abstract");
    String _name = svc.getName();
    String _formatServiceName = Extensions.formatServiceName(_name);
    _builder.append(_formatServiceName, "");
    _builder.append("Configuration extends OperationServiceConfiguration {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("private OperationConfigurationRegistry mOperationConfigurationRegistry = new ");
    String _name_1 = svc.getName();
    String _formatServiceName_1 = Extensions.formatServiceName(_name_1);
    _builder.append(_formatServiceName_1, "	");
    _builder.append("OperationConfigurationRegistry();");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("public OperationConfigurationRegistry getOperationConfigurationRegistry() {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return mOperationConfigurationRegistry;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence generateStub(final Model model) {
    StringConcatenation _builder = new StringConcatenation();
    ServiceBlock svc = model.getService();
    _builder.newLineIfNotEmpty();
    _builder.append("/*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* Generated by Robotoworks Mechanoid");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    _builder.append("package ");
    String _packageName = model.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("public class ");
    String _name = svc.getName();
    String _formatServiceName = Extensions.formatServiceName(_name);
    _builder.append(_formatServiceName, "");
    _builder.append("Configuration extends Abstract");
    String _name_1 = svc.getName();
    String _formatServiceName_1 = Extensions.formatServiceName(_name_1);
    _builder.append(_formatServiceName_1, "");
    _builder.append("Configuration {");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
}
